package sam.machine.active ; 

/**
  * abstract for ActiveRule and ActiveRewrite
  * @version 3/14/2023 (π day) 
   */
public abstract class ActiveInference implements Runnable {}

/*  NOTE
  Every ActiveInference is generate by either a 
  source program Rule or Rewrite or by a new 
  equality fact added to branch by the InferenceManager, 
  in which case inference credit is attributed to 
  the equality fact and the fact that was rewritten.
      true ...
        |
       a=b  i  // ActiveRewrite generated
        | ...
        |
       p(a) j
        |
       p(b)    // "rewrite fact j using i"
        ...
  See ADN§6.5 regarding active rewrite methodology
  descriptions.

*/
