package sam.machine.active ;

import sam.machine.lang.* ;

/**
  * ActiveRewrite motivated by 
  * sam.machine.engine.ActiveMod concurrent test prototype
  * @version 4/4/2023 
   */
public class ActiveRewrite extends ActiveInference implements Runnable {
   public boolean dynamic ;  
   public int atFact ; // branch fact# if dynamic
   public Term Lterm, Rterm ; 
   public int index ; // set by ActiveTheory if static or
                      // by ActiveTree if dynamic

   /** 
     * Construct new ActiveRewrite corresponding  
     * to program source Rewrite.
      */
   public ActiveRewrite(Rewrite rewrite) {      
      this.dynamic = false ; 
      this.Lterm = rewrite.Lterm ;
   } 

   /** 
     * Construct new ActiveRewrite corresponding  
     * to dynamically generated ground equality fact.
      */
   public ActiveRewrite(int index, Functor left, Functor right) { 
      this.dynamic = true ; // generated by fact left=right
      this.atFact = index ;
      this.Lterm = left ;
      this.Rterm = right ;
   } 
 


  public void run() { 
     // under construction 
  }

}     

